VERSION 5.00
Begin VB.Form MousePicking 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   5265
   ClientLeft      =   2580
   ClientTop       =   2070
   ClientWidth     =   4770
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5265
   ScaleWidth      =   4770
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "MousePicking"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'------------------------------------
' TrueVision 8 Mouse Picking Sample
'------------------------------------
'
'  27/12/2000
'
'------------------------------------------
' ANY BUG ? ANY PROBLEM ?
' Mail Sylvain At sylvain@truevision3d.com
'-----------------------------------------

'General declaration
'
Public TV As New TrueVision8
Public Scene As New Scene8
Public Inp As New InputEngine8
Public Scr As New Screen8
Public Camera As New Camera8

'Actors & Terrains
Public Land As New Landscape8
Public Actor As New Actor8


'Info on Mouse
Public Mx As Long, My As Long, b1 As Integer

'Info about MousePicking
Public Pick As CollisionResult8
Public BoneTouched As String

'Info about position and path
Private Direction As D3DVECTOR, Destination As D3DVECTOR
Public PosX As Single, PosZ As Single, PosY As Single
Private Sub Form_Load()
  'General Error Handler
  On Error Resume Next
  
  '1. Init TrueVision with FullScreen mode
  If TV.ShowDriverDialog = False Then End
  TV.Initialize
  TV.DisplayFPS = True

  '2. Set the default directory
  TV.SetSearchDirectory App.Path
  
  '3. Load the cursor
  'NB : When you load a cursor, the cursor rendering is
  'automatically enabled. If you want to stop it, use
  'the SetCursorTexture method with Nothing as texture
  Scene.LoadCursor "arrow.bmp", TV_COLORKEY_BLACK, 14, 16
  
  '4. Load the actor
  Actor.SetSpeed 1
  Actor.Load "scientist.mdl"
  Actor.SetAnimationName "idle"
  Actor.SetRotation -90, 90, 0
  Actor.SetPosition 500, 20, 500
  
  '5. Camera setting
  PosX = 200
  PosZ = 200
  Camera.SetCameraPosition PosX, 50, PosZ
  
  '6. Load the skybox
  Scene.LoadTexture "up2.jpg", , , "Up"
  Scene.LoadTexture "down2.jpg", , , "Down"
  Scene.LoadTexture "left2.jpg", , , "Left"
  Scene.LoadTexture "right2.jpg", , , "Right"
  Scene.LoadTexture "front2.jpg", , , "Front"
  Scene.LoadTexture "back2.jpg", , , "Back"
  Scene.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("Down"), GetTex("Up")
  
  '7. Load the terrain
  Land.SetFactorY 0.3
  Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True
  Scene.LoadTexture "terrain.jpg", , , "TerrainTexture"
  Land.SetTexture GetTex("TerrainTexture")
  Land.SetTextureScale 2, 2
  
  'Create a user font
  Scr.CreateUserFont "TrueFont", "Arial", 10, True, True, False
  
  'Game loop
  Do
     TV.Clear
     Land.Render
     Actor.Render
     Scene.RenderSky
     'Write the bone picked on the screen
     'NB : TEXT FUNCTION MUST BE CALLED JUST BEFORE RENDERING TO THE SCREEN.
     Scr.DrawText "MDL Bone Picked : " + CStr(BoneTouched), 5, 50, RGBA(1, 0, 0, 1), "TrueFont"
     
     TV.RenderToScreen
     
     'Mouse pick stuff
     'Get the mouse state with the absolute mode.
     Inp.GetAbsMouseState Mx, My, b1
     
     'Terrain Picking
     If b1 <> 0 Then
       Set Pick = Scene.MousePicking(Mx, My, TV_COLLIDE_LANDSCAPE, TV_TESTTYPE_ACCURATETESTING)
       If Pick.IsCollision = True Then
         'You can get the picked point with the ImpactPoint method
         Destination = Pick.GetImpactPoint
         Direction = VNormalize(VSubtract(Destination, Vector(PosX, PosY, PosZ)))
         'Obtain the angle with trigo maths
         If Direction.z > 0 Then
           angle = Rad2Deg(Atn(Direction.x / Direction.z))
         Else
           angle = Rad2Deg(Atn(Direction.x / Direction.z)) + 180
         End If
         Actor.SetRotation -90, -90 + angle, 0
         Walk = True
         Actor.SetAnimationName "walk"
       End If
     End If
     
     'Makes the scientist walking
     If Walk = True Then
       Dim p As D3DVECTOR
       p = VAdd(Vector(PosX, PosY, PosZ), VScale(Direction, TV.TimeElapsed * 0.05))
       PosX = p.x
       PosZ = p.z
       If Int(PosX / 2) = Int(Destination.x / 2) And Int(PosZ / 2) = Int(Destination.z / 2) Then
         'If he's reached his destination, stop it !
         Walk = False
         Actor.SetAnimationName "idle"
       End If
     End If
     'Actors are have a little bit different method for mousepicking
     'You have to use a Macro function : ActorPicking.
     ActorPicking Actor, BoneTouched
     'This function returns BoneTouched that indicates which bone has been picked.
     'Useful for FPS games (Shoot on head, or on body...)
     
     'Place the scientist over the terrain
     PosY = Land.GetHeight(PosX, PosZ)
     Actor.SetPosition PosX, PosY, PosZ
     
     'The camera has to roll over the landscape !
     Camera.PurchaseFollowing Actor.GetModelMesh, Vector(30, 30, 200), Vector(0, 0, 50), 40, False, 100, False
     Camera.SetCameraPosition Camera.GetCameraPosition.x, Land.GetHeight(Camera.GetCameraPosition.x, Camera.GetCameraPosition.z) + 50, Camera.GetCameraPosition.z
  
  Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
  
  Set TV = Nothing
  End

  
End Sub


